export default class Transform {
    constructor() {
        this.position = [0, 0, 0];
        this.rotation = [0, 0, 0];
        this.scale = [1, 1, 1];
    }

    /**
     * Build an affine mat4 transform that represents the current state
     */
    getMat4() {
        const m = glMatrix.mat4.create();
        const q = glMatrix.quat.create();
        glMatrix.quat.fromEuler(q, ...this.rotation);
        glMatrix.mat4.fromRotationTranslationScale(m, q, this.position, this.scale);

        return m;
    }

    setPosition(x, y, z) {
        this.position = [x, y, z];
    }

    getRotation() {
        return this.rotation.slice();
    }

    setRotation(rx, ry, rz) {
        this.rotation = [rx, ry, rz];
    }

    setScale(sx, sy, sz) {
        this.scale = [sx, sy, sz];
    }
}